/*****************************************************************

This is a console implementation of the display class for the 
CES system. This set up a VIF (Visual interface, 
Verry Important Force, or Verry Important For.us, if you like.

This uses the conio hack for linux, which uses ncurses.

*****************************************************************/

#include <stdlib.h>
#include <string.h>
#include "cestypes.h"

#ifndef _VIF

#define _VIF


#define XDim_t int64_t
#define YDim_t int64_t

class VIF {

 public:

  long int Height;
  long int Width;

  char *   BuffText;
  char *   BuffProp;
  int64_t  BuffPtr;
  int64_t  BUFFLEN;

  VIF();
  void     CursorPos ( XDim_t X, YDim_t Y );
  void     WriteText ( char * text );
  void     WriteText ( char * text, char * properties);

  void     BufferText( char * text, char * properties);
  void     GetBuffer ( char * text, char * properties, long int N);
  void     BufferPos ( XDim_t X, YDim_t Y );
  void     ReDraw    ( void );

  ~VIF();

};

#endif







