/***************************************************************

Description:
  This is a a taylored linked list system for holding noncontent editor data. 
   Nodes are sorted by owner, then index. they are sorted at creation time.

 This code could be optimized by keeping the tag list sorted by owner and
   index, but in the hurry to get it to work, wasn't done.

Methods:
  -- shared methods --
  int    Set   (owner, index, position, type);  
  tag  * Get   (owner, index, tag *);
  int    Delete(owner, index);
  int    Delete(owner);


  -- internal methods --


 Dont use tab characters in this code.
  Dont use tab characters in this code.
   Dont use tab characters in this code.
    Dont use tab characters in this code.
     Dont use tab characters in this code.
      Dont use tab characters in this code.
       Dont use tab characters in this code.
        Dont use tab characters in this code.
         Dont use tab characters in this code.
          thanks.

History: 
 Creation Dan, <Jul 8 2002>
 modified to use new linked list code. Jeff, <Jul 26 2002>
 

***************************************************************/

#include <stdlib.h>
//#include <string.h>
#include "cestypes.h" 
#include "propaccumulator.h" // class definition
//#include "dll.h"       // dual linked lists...

#include "stdio.h"  //printf



PropAccum::PropAccum() {
  // initialize the linked list.
  //propList = NULL;
}

PropAccum::~PropAccum() {
   //deleteAll();
}

/*************************************************
*
* FREE THE NODES. FREE ALL THE NODES. FREE THEM NOW!
*
**************************************************/
void PropAccum::deleteAll() {

   propList.erase(propList.begin(),propList.end());
}


/*****************************************
*
* Description:
*  try to find (owner, index) node 
*  if  not found - create
*    if found -modify other attributes
*  else err
*
* In:
*  Owner:    level 1 identity. e.g. the 
*    client identity.
*  Index:    level 2 identity. e.g. the 
*    bookmark number of the client.
*  Position: The character offset of this
*    tag. the purpose for its existance.
*  Type:     Used when interperting tags
*             to know what it is e.g.
*             cursor or bookmark.
*
* Out:
*  1 = success
*  0 = failure
*
* converted.
*****************************************/
int PropAccum::set(int64_t Owner, int64_t Index, int64_t Position, int Type) {

  Tag * node; // cesfieldtag is same as tagnode

  // lookup tag
  node = find(Owner, Index);
  // if the tag dosn't exist
  if (node == NULL) {         
    if (insert(Owner, Index, Position, Type)) {  // create tag  // if the tag exists            
      modify(node, Position, Type); // set attributes   
    } else {
      return 0; // fail! fail!
    }   
  } else {
    modify(node, Position, Type);
  }
   
  return 1; // in some form, shape , or manner, it worked.
}

/****************************************
*
* Find a node with the given owner and index.
*
* IN:
*   Owner: find a tag with a matching owner and
*   Index: find a tag with a matching index
*
* OUT:
*   Success: Pointer to tag
*   Failure: NULL   
*
* converted.
****************************************/
Tag * PropAccum::find(int64_t owner, int64_t index) {

  const_iterator<Tag> citr;
  
  Tag * temp;
  
  for (citr = propList.begin();citr != propList.end(); citr++)
  {
     temp = &citr.getPointAt().getValue();
     
     if (temp->getOwner() == owner)
       if (temp->getIndex() == index) { //found
          temp = NULL; 
          return &citr.getPointAt();
       }
  }
  return NULL;//not found
  
}


/*****************************************************
 *
 * Insert a data set into the linked list.
 *
 * IN:
 *  Owner:    Main identity number
 *  Index:    Sub identity number
 *  Position: Value to set position to
 *  Type:     Tag type to set 
 *
 * OUT:
 *  1 = success
 *  0 = failure
 *
 * converted.
 ****************************************************/
int PropAccum::insert(int64_t Owner, int64_t Index, int64_t Position, int Type) {

  Tag temp;
  
  temp.setOwner(Owner);  // the hard way? what do you mean?
  temp.setIndex(Index);
  temp.setPosition(Position);
  temp.setType(Type);
  
  propList.push_back(temp);
    
}


//    modify(node, Position, Type);
/************************************************
 *
 * Modify the data of a node.
 * Why is this a method instead of just doing it?
 *  ... I dont know...
 *
 * IN:
 *  node:      Pointer to the node to modify
 *  Position:  The new value for the Position
 *  Type:      The new value fot the Type
 *
 * OUT:
 *  void
 *
 * converted.
 ***********************************************/
void PropAccum::modify(Tag * node, int64_t Position, int64_t Type) {
  
  node->setPosition(Position);
  node->setType(Type);

  // whoo! that was a tuffie!, hope I didn't make any ERRorS!

  return;
}


/*
* Direct Method
*/
int PropAccum::set(Tag * Data) {
  
  // !!!???!!! Write me!
  printf("PropAccum::Set(CES_FIELD_TAG *) was called, but hasn't been written yet.\n");
  
  return 1;
}

/*****************************************
*
* Description:
*  Get a tag.
*
* In:
*  Owner:    level 1 identity. e.g. the 
*    client identity.
*  Index:    level 2 identity. e.g. the 
*    bookmark number of the client.
*  Dest:     pointer to a tag to put the
*    result in.
*
* Out:
*  Success: Same as Dest.
*  Failure: NULL
*
* converted.
*****************************************/
Tag * PropAccum::get(int64_t Owner, int64_t Index, Tag * Dest) {

  Tag * node;
  
  // find it.
  node = find(Owner, Index);
  
  // if the tag exists
  if (node != NULL) {
    // set tag
    Dest->setPosition( node->getPosition());
    Dest->setOwner(    node->getOwner()   );
    Dest->setIndex(    node->getIndex()   );
    Dest->setType(     node->getType()    );
    return Dest;
  } 
  
  return NULL;
}








