/**************************************************
*
* History: 
*  Creation Dan, <Jul 8 2002>
*
**************************************************/ 
 
#ifndef _PROPACCUM
#define _PROPACCUM
#include <stdlib.h> // int64_t
#include "dll.h" //double link list

#define CES_FIELD_TAG  Tag

//also named in some places: CES_FIELD_TAG
// this is a data sector for the linked list nodes.

class Tag {
   public:
      Tag( long own =0, long ind =0, int64_t pos =0 , int t =0)
        :position(pos), owner(ind),index(ind),type(t){}
      
      int64_t getPosition() const{return position;}
      void    setPosition(int64_t pos=0){ position = pos; }
      
      long    getOwner   ()const{return owner;}
      void    setOwner   (long own=0){owner = own;}
      
      long    getIndex   ()const{return index;}
      void    setIndex   (long ind=0){index = ind;}
      
      int     getType    ()const{return type;}
      void    setType    (int t=0){type = t;}
      
   private:
      int64_t  position;      // first character effected 
      long     owner   ;      // unique within scope of editor 
      long     index   ;      // uniquie within scope of owner
      int      type    ;      // reference for translation of tag type
};


// this is the actual linked list of tag nodes.

class PropAccum {

 public:
                   PropAccum();
                  ~PropAccum();
                  
 int               set (int64_t Owner, int64_t Index, int64_t Position, int Type);
 int               set (Tag * Data);
 Tag           *   get (int64_t Owner, int64_t Index, Tag * Dest);
 
 Tag           *   find(int64_t Owner, int64_t Index);
 bool              removeNode(int64_t Owner, int64_t Index);
 
 private:
 
  List<Tag>  propList;//double link list (currently)
 
  int              insert   (int64_t Owner, int64_t Index, int64_t Position, int Type);
  void             modify   (Tag * node, int64_t Position, int64_t Type);
  void             deleteAll();

};

#endif
